<?php

namespace Picea\Ui\Form;

class UiTextarea extends UiInput {

    public array $tokens = [ "ui:textarea" ];

    public string $tag = "textarea";

    public array $attributes = [
       'class' => "ui-textarea",
    ];
    
    public array $options = [];

    protected bool $echoRaw = false;

    public function parse(\Picea\Compiler\Context &$context, ?string $arguments, string $token) : string
    {
        $raw = in_array('raw', $context->tokenOptions($token)) ? 'true' : 'false';

        return "<?php echo ( new \\" . static::class . "() )->echoRaw($raw)->buildHtml($arguments) ?>";
    }

    protected function setValue($value) : void
    {
        $this->echoRaw ? $this->html($value) : $this->text($value);
    }

    public function echoRaw(bool $set) : self
    {
        $this->echoRaw = $set;

        return $this;
    }
}
